/**
*  AttributeWatcher is responsible for the subscription/publication of
*  all the attributes of particular class. It will registers all the puiblishing
*  activities and broadcast this all the subscribed federates.
*
*/

import RTIcap.*;
import java.util.*;

/**
*/
public class AttributeWatcher 
{
   ObjectRecord father;      // Object 
   short        theHandle;
   String       theName;
   Hashtable    subscribers = new Hashtable();  // Subscribers
   Hashtable    publishers  = new Hashtable();  // Publishers

   /**
   *
   */
   public
   AttributeWatcher(ObjectRecord _boss, short _theHandle, String _theName) 
   { 
       father = _boss;
       theHandle = _theHandle;
       theName   = _theName;

   }// end of CONSTRUCTOR

   /**
   *
   */
   public void
   subscribe(FederateAmb _fedAmb, short fedHandle)
   {
      subscribers.put(new Short(fedHandle),_fedAmb);

   }// end of subscribe()

   /**
   *
   */
   public void
   unsubscribe(short fedHandle)
   {
      subscribers.remove(new Short(fedHandle));

   }// end of subscribe()

   /**
   *
   */
   public void
   publish(short sourceFed)
   {
      Enumeration e = subscribers.keys();
      for(;e.hasMoreElements();)
      {
         Short key = (Short) e.nextElement();
         FederateAmb n = (FederateAmb) subscribers.get(key);

         if(n!=null && key.shortValue()!=sourceFed) {};

      }// end of for

   }// end of publish()

   /**
   *
   */
   public void
   register_publisher(FederateAmb _fedAmb, short fedHandle)
   {
    
      FederateAmb n = (FederateAmb) publishers.get(new Short(fedHandle));
   
      if(n==null) publishers.put(new Short(fedHandle),_fedAmb);
      
   }// end of register_publisher()

   /**
   *
   */
   public void
   deregister_publisher(short fedHandle)
   {
    
      FederateAmb n = (FederateAmb) publishers.get(new Short(fedHandle));
   
      if(n==null) publishers.remove(new Short(fedHandle));
      
   }// end of register_publisher()

}// end of class AttributeWatcher

